// LEGAL NOTICE: This code follows the GNU licence.
// Authors: Oscar Chavarro & Camilo Nemocon

package vrpnforprocessing;

import java.io.*;
import java.util.*;
import vrpn.*;
import vrpn.AnalogRemote.AnalogUpdate;
import vrpn.AnalogRemote;


public class vrpnJoystick
	implements vrpn.AnalogRemote.AnalogChangeListener

{
        private static double arr[] = new double[12];

	public void analogUpdate( AnalogUpdate u, AnalogRemote tracker )
	{
		int i;
                for ( i = 0; i < u.channel.length && i < 12; i++ ) {
                    arr[i] = u.channel[i];
                }
        }


        public float getValue(int i)
        {
            if ( i < 0 || i >= 12 ) {
                return 0.0f;
            }
            return (float)arr[i];
        }

	public void connect(String joystickName)
	{
		AnalogRemote analog = null;
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		try
		{
			analog = new AnalogRemote( joystickName, null, null, null, null );
		}
		catch( InstantiationException e )
		{
			System.out.println( "We couldn't connect to tracker " + joystickName + "." );
			return;
		}
		
		vrpnJoystick test;
                test = new vrpnJoystick();
		analog.addAnalogChangeListener( test );
                System.out.println("vrpnJoystick connection ready!");
	}
	
}
